pcr_relay_no_adapter_scope() {
    PCR_RELAY_NO_ADAPTER_SCOPE=0
    if [ -f /etc/init.d/relay_adapter ]; then
        if [ -d /tmp/service.d/relay_adapter/ ]; then
            if [ "`sv status /tmp/service.d/relay_adapter/ |sed -e  's/^\([a-z]*\).*/\1/g'`" = "run" ]; then
                PCR_RELAY_NO_ADAPTER_SCOPE=1
            fi
        elif [ -f /var/run/relay_adapter.lua ]; then
            PCR_RELAY_NO_ADAPTER_SCOPE=1
        else
            for P in /proc/* ; do
                if [ -d $P ] && [ $P/exe -ef "`which lua`" ] && tr '\0' '\n' <$P/cmdline | grep -qs "`which relay_adapter.lua`"; then
                    PCR_RELAY_NO_ADAPTER_SCOPE=1
                    break
                fi
            done
        fi
        /etc/init.d/relay_adapter stop
    fi
    "$@"
    if [ "$PCR_RELAY_NO_ADAPTER_SCOPE" = 1 ] && [ -z "$PCR_DELAYED_COMMAND_REQUIRING_REBOOT" ] && [ -z "$PCR_REQUIRE_REBOOT_ON_SHUTDOWN" ]; then
        /etc/init.d/relay_adapter start
    fi
}

pcr_environment_scope_internal() {
    if [ -f "$HERE"/SKIP_CONFIRM ]; then
        PCR_SKIP_CONFIRM="1"
    else
        PCR_SKIP_CONFIRM=""
    fi
    if [ -f "$HERE"/SKIP_DONE ]; then
        PCR_SKIP_DONE="1"
    else
        PCR_SKIP_DONE=""
    fi
    if [ -f "$HERE"/WIFI_DOWN_ON_SHUTDOWN ]; then
        PCR_WIFI_DOWN_ON_SHUTDOWN="1"
    else
        PCR_WIFI_DOWN_ON_SHUTDOWN=""
    fi
    pcr_relay_detect
    OLD_INITTAB=`mktemp`
    cp /etc/inittab "$OLD_INITTAB"
    sed -i -e "/^$PCR_RELAY_PORT::[^:]*:[/]bin[/]ash/d" /etc/inittab
    if ! cmp /etc/inittab "$OLD_INITTAB"; then
        killall -HUP init
        mv -f "$OLD_INITTAB" /etc/inittab
    else
        rm "$OLD_INITTAB"
        OLD_INITTAB=""
    fi
    if pcr_relay_ensure_controlled_use_only && pcr_relay_ensure_link; then
        pcr_reset_ui
        "$@"
        if [ -n "$OLD_INITTAB" ]; then
            killall -HUP init
        fi
    fi
}

pcr_environment_scope() {
    if [ -f /tmp/.pcr_update_in_progress ]; then
        return 1
    fi
    touch /tmp/.pcr_update_in_progress
    PCR_ASYNC_UPDATE_IN_PROGRESS=""
    pcr_relay_no_adapter_scope pcr_environment_scope_internal "$@"
    if [ -n "$PCR_DELAYED_COMMAND_REQUIRING_REBOOT" ]; then
        if [ -n "$PCR_REQUIRE_COMPLETION" ]; then
            PCR_ASYNC_UPDATE_IN_PROGRESS="1"
            trap '' HUP
            (sleep 5; $PCR_DELAYED_COMMAND_REQUIRING_REBOOT; reboot; sleep 2; reboot -f ) >/dev/null </dev/null 2>&1 &
        else
            $PCR_DELAYED_COMMAND_REQUIRING_REBOOT
            reboot
            sleep 2
            reboot -f
        fi
    elif [ -n "$PCR_REQUIRE_REBOOT_ON_SHUTDOWN" ]; then
        if [ -n "$PCR_REQUIRE_COMPLETION" ]; then
            PCR_ASYNC_UPDATE_IN_PROGRESS="1"
            trap '' HUP
            (sleep 5; reboot; sleep 2; reboot -f) >/dev/null </dev/null 2>&1 &
        else
            reboot
            sleep 2
            reboot -f
        fi
    fi
    if [ -n "$PCR_WIFI_DOWN_ON_SHUTDOWN" ]; then
        if [ -n "$PCR_REQUIRE_COMPLETION" ]; then
            trap '' HUP
            (sleep 1;wifi down) >/dev/null </dev/null 2>&1 &
        else
            wifi down
        fi
    fi
    if [ -z "$PCR_ASYNC_UPDATE_IN_PROGRESS" ]; then
        rm /tmp/.pcr_update_in_progress
    fi
}
